// (c) 2003, Ivan Yanikov, dobrokot 'at' gmail.com 


#ifndef _MATRIX_4x4_HAS_YOU_
#define _MATRIX_4x4_HAS_YOU_

#include <math.h>
#pragma hdrstop

//warning!!!
//elements matrix[3,0], matrix[3,0], matrix[3,0], matrix[3,0] are fictive.
//They are ignored by functions in parameters and forced to be 0,0,0,1 after
//function finish work. They are processed as they are 0,0,0,1.
//(except mtTranspose(matrix, const matrix) function)

//warning!!!
//See comments before mtCmps  and  mtInvert declarations.


typedef float RealType;
#define RealTypePtr dword ptr
#define SizeOfRealType 4
/**/

/*
typedef double RealType;
#define RealTypePtr qword ptr
#define SizeOfRealType 8
/**/

typedef RealType matrix[4][4];
struct point3d
{
  RealType x,y,z;
  point3d() {};
  point3d(RealType x, RealType y, RealType z)
  {
    this->x=x; this->y=y; this->z=z;
  };
};

inline RealType mtNorm (const point3d *p);
inline RealType mtSqrNorm (const point3d *p);
//inline void mtSub(point3d *Result, const point3d *p);
inline point3d &operator-=(point3d &p2, const point3d &p1);
inline point3d operator-(point3d &p2, const point3d &p1);
inline void mtSubR(point3d *Result, const point3d *p);
//inline void mtAdd(point3d *Result, const point3d *p);
inline point3d &operator+=(point3d &p1,const point3d &p2);
inline point3d operator+(point3d &p1,const point3d &p2);
//&Result != p1, &Result != p2
//inline void mtVectMul(point3d *Result, const point3d *p1, const point3d *p2);
inline point3d operator^ (const point3d &p1, const point3d &p2);
//inline RealType mtScalMul(const point3d *p1, const point3d *p2);
inline RealType operator*(const point3d &p1, const point3d &p2);
//inline void mtRealMul(point3d *Result, const point3d *p1, float a);
inline point3d &operator*=(point3d &p1, RealType a);

void mtMovPoint(point3d *NewP, const point3d OldP, const matrix m);
void mtMovVect(point3d *NewV, const point3d OldV, const matrix m);

//&m3 != &m1, &m3 != &m1.
void mtCmps(matrix m3, const matrix m2, const matrix m1);
//&m2 != &m1.
void mtInvert(matrix m2, const matrix m1);
//&m2 != &m1.
void mtTranspose(matrix m2, const matrix m1);
void mtCopy(matrix m2, const matrix m1);
void mtSetE(matrix m);
void mtRotatex(matrix m, RealType a);
void mtRotatey(matrix m, RealType a);
void mtRotatez(matrix m, RealType a);
void mtTranslate(matrix m, RealType x, RealType y, RealType z);
void mtScale(matrix m, RealType p, RealType q, RealType r);

RealType mtNorm (point3d *p)
{
  return sqrt(p->x*p->x+p->y*p->y+p->z*p->z);
  /*asm {
    //return value in st(0)
    push esi
    mov esi,p
    fld  RealTypePtr [esi+SizeOfRealType*0]
    fmul st,st(0)
    fld  RealTypePtr [esi+SizeOfRealType*1]
    fmul st,st(0)
    fadd
    fld  RealTypePtr [esi+SizeOfRealType*2]
    fmul st,st(0)
    fadd
    fsqrt
    pop esi
  }/**/
}


inline RealType mtSqrNorm (point3d *p)
{
  return (p->x*p->x+p->y*p->y+p->z*p->z);
  /*asm {
    //return value in st(0)
    push esi
    mov esi,p
    fld  RealTypePtr [esi+SizeOfRealType*0]
    fmul st,st(0)
    fld  RealTypePtr [esi+SizeOfRealType*1]
    fmul st,st(0)
    fadd
    fld  RealTypePtr [esi+SizeOfRealType*2]
    fmul st,st(0)
    fadd
    pop esi
  }/**/
}


//inline void mtSub(point3d *Result, const point3d *p)
inline point3d &operator-=(point3d &p2, const point3d &p1)
{
  p2.x-=p1.x;
  p2.y-=p1.y;
  p2.z-=p1.z;
  return p2;
}


inline point3d operator-(const point3d &p2, const point3d &p1)
{
  point3d r;
  r.x=p2.x-p1.x;
  r.y=p2.y-p1.y;
  r.z=p2.z-p1.z;
  return r;
}



inline void mtSubR(point3d *Result, const point3d *p)
{
  Result->x=p->x-Result->x;
  Result->y=p->y-Result->y;
  Result->z=p->z-Result->z;
}

//inline void mtAdd(point3d *Result, const point3d *p)
inline point3d &operator+=(point3d &p1,const point3d &p2)
{
  p1.x+=p2.x;
  p1.y+=p2.y;
  p1.z+=p2.z;
  return p1;
}


inline point3d operator+(const point3d &p1,const point3d &p2)
{
  point3d r;
  r.x=p1.x+p2.x;
  r.y=p1.y+p2.y;
  r.z=p1.z+p2.z;
  return r;
}


//inline void mtVectMul(point3d *Result, const point3d *p1, const point3d *p2)
inline point3d operator^ (const point3d &p1, const point3d &p2)
{
  point3d r;
  r.x=+p1.y*p2.z-p2.y*p1.z;
  r.y=-p1.x*p2.z+p2.x*p1.z;
  r.z=+p1.x*p2.y-p2.x*p1.y;
  return r;
}


inline RealType operator*(const point3d &p1, const point3d &p2)
{
  return p1.x*p2.x+p1.y*p2.y+p1.z*p2.z;
}


//inline void mtRealMul(point3d *Result, const point3d *p1, float a)
inline point3d &operator*=(point3d &p1, RealType a)
{
  p1.x*=a;
  p1.y*=a;
  p1.z*=a;
  return p1;
}


void mtCmps(matrix m3,const matrix m2, const matrix m1)
{
  m3[0][0]=m2[0][0]*m1[0][0] + m2[0][1]*m1[1][0] + m2[0][2]*m1[2][0];
  m3[0][1]=m2[0][0]*m1[0][1] + m2[0][1]*m1[1][1] + m2[0][2]*m1[2][1];
  m3[0][2]=m2[0][0]*m1[0][2] + m2[0][1]*m1[1][2] + m2[0][2]*m1[2][2];
  m3[0][3]=m2[0][0]*m1[0][3] + m2[0][1]*m1[1][3] + m2[0][2]*m1[2][3] + m2[0][3];
  m3[1][0]=m2[1][0]*m1[0][0] + m2[1][1]*m1[1][0] + m2[1][2]*m1[2][0];
  m3[1][1]=m2[1][0]*m1[0][1] + m2[1][1]*m1[1][1] + m2[1][2]*m1[2][1];
  m3[1][2]=m2[1][0]*m1[0][2] + m2[1][1]*m1[1][2] + m2[1][2]*m1[2][2];
  m3[1][3]=m2[1][0]*m1[0][3] + m2[1][1]*m1[1][3] + m2[1][2]*m1[2][3] + m2[1][3];
  m3[2][0]=m2[2][0]*m1[0][0] + m2[2][1]*m1[1][0] + m2[2][2]*m1[2][0];
  m3[2][1]=m2[2][0]*m1[0][1] + m2[2][1]*m1[1][1] + m2[2][2]*m1[2][1];
  m3[2][2]=m2[2][0]*m1[0][2] + m2[2][1]*m1[1][2] + m2[2][2]*m1[2][2];
  m3[2][3]=m2[2][0]*m1[0][3] + m2[2][1]*m1[1][3] + m2[2][2]*m1[2][3] + m2[2][3];
  m3[3][0]=0;   m3[3][1]=0;   m3[3][2]=0;   m3[3][3]=1;
}


void mtInvert(matrix m2, const matrix m1)
{
  RealType d;
  d=+ m1[0][0]*m1[1][1]*m1[2][2]
    + m1[1][0]*m1[2][1]*m1[0][2]
    + m1[2][0]*m1[0][1]*m1[1][2]
    - m1[2][0]*m1[1][1]*m1[0][2]
    - m1[0][0]*m1[2][1]*m1[1][2]
    - m1[1][0]*m1[0][1]*m1[2][2];
  m2[0][0]= (m1[1][1]*m1[2][2] - m1[2][1]*m1[1][2]) / d;
  m2[0][1]= (m1[2][1]*m1[0][2] - m1[0][1]*m1[2][2]) / d;
  m2[0][2]= (m1[0][1]*m1[1][2] - m1[1][1]*m1[0][2]) / d;
  m2[0][3]= -(+ m1[0][3]*m1[1][1]*m1[2][2]
              + m1[1][3]*m1[2][1]*m1[0][2]
              + m1[2][3]*m1[0][1]*m1[1][2]
              - m1[2][3]*m1[1][1]*m1[0][2]
              - m1[0][3]*m1[2][1]*m1[1][2]
              - m1[1][3]*m1[0][1]*m1[2][2]) / d;
  m2[1][0]= (m1[2][0]*m1[1][2] - m1[1][0]*m1[2][2]) / d;
  m2[1][1]= (m1[0][0]*m1[2][2] - m1[2][0]*m1[0][2]) / d;
  m2[1][2]= (m1[1][0]*m1[0][2] - m1[0][0]*m1[1][2]) / d;
  m2[1][3]=-(+ m1[0][0]*m1[1][3]*m1[2][2]
             + m1[1][0]*m1[2][3]*m1[0][2]
             + m1[2][0]*m1[0][3]*m1[1][2]
             - m1[2][0]*m1[1][3]*m1[0][2]
             - m1[0][0]*m1[2][3]*m1[1][2]
             - m1[1][0]*m1[0][3]*m1[2][2]) / d;
  m2[2][0]= (m1[1][0]*m1[2][1] - m1[2][0]*m1[1][1]) / d;
  m2[2][1]= (m1[2][0]*m1[0][1] - m1[0][0]*m1[2][1]) / d;
  m2[2][2]= (m1[0][0]*m1[1][1] - m1[1][0]*m1[0][1]) / d;
  m2[2][3]=-(+ m1[0][0]*m1[1][1]*m1[2][3]
             + m1[1][0]*m1[2][1]*m1[0][3]
             + m1[2][0]*m1[0][1]*m1[1][3]
             - m1[2][0]*m1[1][1]*m1[0][3]
             - m1[0][0]*m1[2][1]*m1[1][3]
             - m1[1][0]*m1[0][1]*m1[2][3]) / d;
  m2[3][0]=0;   m2[3][1]=0;   m2[3][2]=0;   m2[3][3]=1;
}


void mtTranspose(matrix m2, const matrix m1)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m2[i][j]=m1[j][i];
}

void mtCopy(matrix m2, const matrix m1)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m2[i][j]=m1[i][j];
}


void mtMovPoint(point3d *NewP, const point3d OldP, const matrix m)
{
  NewP->x= m[0][0]*OldP.x+m[0][1]*OldP.y+m[0][2]*OldP.z+m[0][3];
  NewP->y= m[1][0]*OldP.x+m[1][1]*OldP.y+m[1][2]*OldP.z+m[1][3];
  NewP->z= m[2][0]*OldP.x+m[2][1]*OldP.y+m[2][2]*OldP.z+m[2][3];
  /**/
  /*
  asm {
    push esi
    push edi
    push ecx
    mov edi,NewP
    mov esi,m
    fld RealTypePtr OldP+SizeOfRealType*0
    fld RealTypePtr OldP+SizeOfRealType*1
    fld RealTypePtr OldP+SizeOfRealType*2
    mov ecx,3
    Row:
      fld RealTypePtr [esi+SizeOfRealType*0]
      fmul st,st(3)
      fld RealTypePtr [esi+SizeOfRealType*1]
      fmul st,st(3)
      fadd
      fld RealTypePtr [esi+SizeOfRealType*2]
      fmul st,st(2)
      fadd
      fadd RealTypePtr [esi+SizeOfRealType*3]
      fstp RealTypePtr [edi]
      add esi,4*SizeOfRealType
      add edi,SizeOfRealType
    dec ecx
    jnz Row
    mov ecx,3
    Free:
      ffree st(0)
      fincstp
    dec ecx
    jnz Free
    pop ecx
    pop edi
    pop esi
  }/**/
}


void mtMovVect(point3d *NewV, const point3d OldV, const matrix m)
{
  NewV->x= m[0][0]*OldV.x+m[0][1]*OldV.y+m[0][2]*OldV.z;
  NewV->y= m[1][0]*OldV.x+m[1][1]*OldV.y+m[1][2]*OldV.z;
  NewV->z= m[2][0]*OldV.x+m[2][1]*OldV.y+m[2][2]*OldV.z;
  /**/
  /*asm {
    push esi
    push edi
    push ecx
    mov edi,NewV
    mov esi,m
    fld RealTypePtr OldV+SizeOfRealType*0
    fld RealTypePtr OldV+SizeOfRealType*1
    fld RealTypePtr OldV+SizeOfRealType*2
    mov ecx,3
    Row:
      fld RealTypePtr [esi+SizeOfRealType*0]
      fmul st,st(3)
      fld RealTypePtr [esi+SizeOfRealType*1]
      fmul st,st(3)
      fadd
      fld RealTypePtr [esi+SizeOfRealType*2]
      fmul st,st(2)
      fadd
      fstp RealTypePtr [edi]
      add esi,4*SizeOfRealType
      add edi,SizeOfRealType
    dec ecx
    jnz Row
    mov ecx,3
    Free:
      ffree st(0)
      fincstp
    dec ecx
    jnz Free
    pop ecx
    pop edi
    pop esi
  }/**/
}


void mtSetE(matrix m)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[0][0]=1;
  m[1][1]=1;
  m[2][2]=1;
  m[3][3]=1;
}


void mtRotatex(matrix m, RealType a)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[0][0]=1;
  m[2][2]=(RealType)cos(a);
  m[2][1]=-(RealType)sin(a);
  m[1][2]=(RealType)sin(a);
  m[1][1]=(RealType)cos(a);
  m[3][3]=1;
}


void mtRotatez(matrix m, RealType a)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[2][2]=1;
  m[0][0]=(RealType)cos(a);
  m[0][1]=-(RealType)sin(a);
  m[1][0]=(RealType)sin(a);
  m[1][1]=(RealType)cos(a);
  m[3][3]=1;
}


void mtRotatey(matrix m, RealType a)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[1][1]=1;
  m[0][0]=(RealType)cos(a);
  m[0][2]=-(RealType)sin(a);
  m[2][0]=(RealType)sin(a);
  m[2][2]=(RealType)cos(a);
  m[3][3]=1;
}


void mtTranslate(matrix m, RealType x, RealType y, RealType z)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[0][3]=x;
  m[1][3]=y;
  m[2][3]=z;
  m[3][3]=m[2][2]=m[1][1]=m[0][0]=1;
}


void mtScale(matrix m, RealType p, RealType q, RealType r)
{
  int i,j;
  for (i=0; i<4;i++)
    for (j=0; j<4;j++)
      m[i][j]=0;
  m[0][0]=p;
  m[1][1]=q;
  m[2][2]=r;
  m[3][3]=1;
}


/*void mtprintmtrx(m :matrix);
begin
   writeln;
   writeln (m[1][1]]['     '][m[1][2]);
   writeln ('          '][m[1][3]]['     '][m[1][4]);
   writeln;
   writeln (m[2][1]]['     '][m[2][2]);
   writeln ('          '][m[2][3]]['     '][m[2][4]);
   writeln;
   writeln (m[3][1]]['     '][m[3][2]);
   writeln ('          '][m[3][3]]['     '][m[3][4]);
end;*/
#undef RealTypePtr
#undef SizeOfRealType
#endif




